#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	ll n;
	cin>>n;
	string a, b;
	cin>>a>>b;
	vector<ll> cm_idx,cd_idx,mc_idx,md_idx;
	vector<ll> dc_idx,dm_idx;
	for(ll i=0;i<n;i++){
		if(a[i]=='C')a[i]='c';
		if(a[i]=='M')a[i]='m';
	}
	for(ll i=0;i<n;i++){
		if(b[i]=='C')b[i]='c';
		if(b[i]=='M')b[i]='m';
	}
	for(ll i=0;i<n;i++){
		if(a[i]==b[i]) continue;
		if(a[i]=='-'){
			if(b[i]=='c') dc_idx.pb(i);
			else if(b[i]=='m') dm_idx.pb(i);
		}
		else if(a[i]=='c'){
			if(b[i]=='m') cm_idx.pb(i);
			else if(b[i]=='-') cd_idx.pb(i);
		}
		else if(a[i]=='m'){
			if(b[i]=='c') mc_idx.pb(i);
			else if(b[i]=='-') md_idx.pb(i);
		}
	}
	//cout<<cm_idx.size()<<" "<<cd_idx.size()<<" "<<mc_idx.size()<<" "<<md_idx.size()<<" "<<dc_idx.size()<<" "<<dm_idx.size()<<endl;
	
	vector<pair<ll,ll>> events;
	char passenger = '-';
	while(cm_idx.size()||mc_idx.size()||cd_idx.size()||md_idx.size()){
		//cout<<cm_idx.size()<<" "<<mc_idx.size()<<" "<<passenger<<endl;
		if(passenger=='-') {
			ll target = -1;
			if(dc_idx.size()) target = dc_idx.back(), dc_idx.pop_back();
			else if(dm_idx.size()) target = dm_idx.back(), dm_idx.pop_back();
			assert(target != -1);
			events.pb({1,target});
			passenger = b[target];
			if(passenger=='c'&&(cm_idx.size()||cd_idx.size())) 
				events.pb({2,0}); // PICKUP c if required somewhere
			else if(passenger=='m'&&(mc_idx.size()||md_idx.size()))
				events.pb({2,0}); // PICKUP m if required somewhere
			else
				passenger = '-';
			
			continue;
		}

		if(passenger=='c'){
			if(cm_idx.size()){
				ll target = -1;
				target = cm_idx.back();
				cm_idx.pop_back();
				events.pb({1,target});
				events.pb({3,0}); //  DROPOFF c
				if(mc_idx.size()||md_idx.size()){
					events.pb({2,0}); // PICKUP m if required somewhere
					passenger = 'm';
				} else {
					passenger = '-';
				}
			}
			else if(cd_idx.size()){
				ll target = -1;
				target = cd_idx.back();
				cd_idx.pop_back();
				events.pb({1,target});
				events.pb({3,0}); //  DROPOFF c
				passenger = '-';
			}
			else {
				// no such case where we have c as passenger
				// and it isn't required anywhere
				assert(false);
			}
			continue;
		}
		
		if(passenger=='m'){
			if(mc_idx.size()){
				ll target = -1;
				target = mc_idx.back();
				mc_idx.pop_back();
				events.pb({1,target});
				events.pb({3,0}); //  DROPOFF m
				if(cm_idx.size()||cd_idx.size()){
					events.pb({2,0}); // PICKUP c if required somewhere
					passenger = 'c';
				} else {
					passenger = '-';
				}
			}
			else if(md_idx.size()){
				ll target = -1;
				target = md_idx.back();
				md_idx.pop_back();
				events.pb({1,target});
				events.pb({3,0}); //  DROPOFF m
				passenger = '-';
			}
			else {
				// no such case where we have c as passenger
				// and it isn't required anywhere
				assert(false);
			}
			continue;
		}
	}
	
	
	cout<<events.size()<<endl;
	for(ll i=0;i<events.size();i++){
		if(events[i].first==1){
			cout<<"DRIVE "<<events[i].second+1<<endl;
		}
		else if(events[i].first==2){
			cout<<"PICKUP"<<endl;
		}
		else{
			cout<<"DROPOFF"<<endl;
		}
	}
	
}
